=== debian/changelog ===
midiminder (1.0.1-1) experimental; urgency=medium

  * Initial release. (Closes: #1091826)

 -- John Horigan <john@glyphic.com>  Sat, 10 May 2025 11:01:52 -0700
