=== debian/control ===
Source: midiminder
Section: sound
Priority: optional
Maintainer: John Horigan <john@glyphic.com>
Build-Depends: debhelper-compat (= 13), libasound2-dev, libfmt-dev, libicu-dev
Standards-Version: 4.7.2
Homepage: https://github.com/mzero/midiminder
Vcs-Git: https://github.com/mzero/midiminder.git
Vcs-Browser: https://github.com/mzero/midiminder
Rules-Requires-Root: no

Package: midiminder
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}, adduser
Description: MIDI connection minder & viewer
 Keeps track of connections between MIDI ports (hardware & software alike).
 If those connections are lost because the hardware disconnects, or the
 software exits, this service will re-make the connections once the ports
 return to the system.
 .
 A configuration of connections can also be stored in a file, and loaded
 at any time, causing the ports to be reconnected according to easy-to-write
 rules.
 .
 Includes the utility command, midiwala, which provides a clear view of the
 ports and connections, and can make and break connections easily.
