=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic

override_dh_auto_install:
	PREFIX=/usr dh_auto_install $@

%:
	dh $@
