=== debian/watch ===
version=4
https://github.com/mzero/midiminder/tags .*/v?(\d.*)@ARCHIVE_EXT@
